# Get directories by type

- Operation ID: `get-type-directories`
- HTTP method: `GET`
- Path: `/template-backend/directory/byType`
- [Human-readable API reference](https://hub.synerise.com/api-reference/campaigns#tag/Template-directories/operation/get-type-directories)

## Self-contained OpenAPI method

The fenced document below contains this method's documentation and all of its local references. It is self-contained; no category or master specification fetch is required.

```yaml
openapi: 3.0.0
info:
  title: Synerise Public API
  version: 1.9.1
paths:
  /template-backend/directory/byType:
    get:
      tags:
        - Template directories
      summary: Get directories by type
      operationId: get-type-directories
      description: |
        Retrieve a list of directories of a single type.

        ---

        **API consumer:** <a href="/api-reference/authorization?tag=Authorization&amp;operationId=userLogin" target="_blank" rel="noopener">Synerise User</a>

        **User role permission required:** `templates: read`
      parameters:
        - in: query
          name: type
          schema:
            type: string
            enum:
              - SMS
              - MOBILE_PUSH
              - WEB_PUSH
              - DYNAMIC_CONTENT
              - LANDING_PAGE
              - EMAIL
              - SOCIAL_MEDIA
              - IN_APP
          description: |
            
            The type of directories to return (directory types match the template types stored in them).

            Directories with null type are always returned.
          required: true
      responses:
        "200":
          description: Directory list
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  description: Details of the directory that includes this template
                  required:
                    - hashId
                    - name
                    - readOnly
                    - createdAt
                    - default
                    - type
                  properties:
                    hashId:
                      type: string
                      format: uuid
                      example: e0326a2d-7697-4ae9-b490-31f97041adcb
                      description: Directory hashId (UUID)
                    name:
                      type: string
                      description: Name of the directory
                    readOnly:
                      type: boolean
                      example: true
                      description: "`true` when the directory is read-only"
                    createdAt:
                      type: string
                      description: Time of creation
                      format: date-time
                      example: 2019-03-21T12:31:26Z
                    type:
                      nullable: true
                      type: string
                      description: Directory type
                      example: EMAIL
                    contentType:
                      type: string
                      enum:
                        - TEMPLATE
                        - BLOCK
                      example: TEMPLATE
                    default:
                      type: boolean
                      example: true
                      description: When `true`, this template belongs to one of the default folders
                    predefined:
                      type: boolean
                      example: true
      security:
        - JWT: []
      x-snr-doc-urls:
        - /api-reference/campaigns#tag/Template-directories/operation/get-type-directories
      x-codeSamples:
        - lang: cURL
          label: cURL
          source: |-
            curl --request GET \
              --url 'https://api.synerise.com/template-backend/directory/byType?type=SOME_STRING_VALUE' \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'
        - lang: Python
          label: Python
          source: |-
            import http.client

            conn = http.client.HTTPSConnection("api.synerise.com")

            headers = { 'Authorization': "Bearer REPLACE_BEARER_TOKEN" }

            conn.request("GET", "/template-backend/directory/byType?type=SOME_STRING_VALUE", headers=headers)

            res = conn.getresponse()
            data = res.read()

            print(data.decode("utf-8"))
        - lang: JavaScript
          label: JavaScript
          source: |-
            const data = null;

            const xhr = new XMLHttpRequest();
            xhr.withCredentials = true;

            xhr.addEventListener("readystatechange", function () {
              if (this.readyState === this.DONE) {
                console.log(this.responseText);
              }
            });

            xhr.open("GET", "https://api.synerise.com/template-backend/directory/byType?type=SOME_STRING_VALUE");
            xhr.setRequestHeader("Authorization", "Bearer REPLACE_BEARER_TOKEN");

            xhr.send(data);
        - lang: Node.js
          label: Node.js
          source: |-
            const http = require("https");

            const options = {
              "method": "GET",
              "hostname": "api.synerise.com",
              "port": null,
              "path": "/template-backend/directory/byType?type=SOME_STRING_VALUE",
              "headers": {
                "Authorization": "Bearer REPLACE_BEARER_TOKEN"
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on("data", function (chunk) {
                chunks.push(chunk);
              });

              res.on("end", function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.end();
        - lang: PHP
          label: PHP
          source: |-
            <?php

            $request = new HttpRequest();
            $request->setUrl('https://api.synerise.com/template-backend/directory/byType');
            $request->setMethod(HTTP_METH_GET);

            $request->setQueryData([
              'type' => 'SOME_STRING_VALUE'
            ]);

            $request->setHeaders([
              'Authorization' => 'Bearer REPLACE_BEARER_TOKEN'
            ]);

            try {
              $response = $request->send();

              echo $response->getBody();
            } catch (HttpException $ex) {
              echo $ex;
            }
        - lang: Java
          label: Java
          source: |-
            HttpResponse<String> response = Unirest.get("https://api.synerise.com/template-backend/directory/byType?type=SOME_STRING_VALUE")
              .header("Authorization", "Bearer REPLACE_BEARER_TOKEN")
              .asString();
servers:
  - description: Microsoft Azure EU
    url: https://api.synerise.com
  - description: Microsoft Azure USA
    url: https://api.azu.synerise.com
  - description: Google Cloud Platform
    url: https://api.geb.synerise.com
tags:
  - name: Template directories
components:
  securitySchemes:
    JWT:
      type: http
      scheme: bearer
      description: |-
        JWT Bearer token. The header looks like this: `Bearer {JWT}`

        Remember to include the space between 'Bearer' and the token.

        Generate a token via the **Authorization** endpoints.
```
